program Patch15;

{$IFDEF Windows}
uses
  WinCrt;
{$ENDIF}

const
  errCorrect = 0;
  errMismatch = 1;
  errNoFile = 2;

procedure Error(Code: Integer);
begin
  case Code of
    errCorrect: Writeln('TPW.TPL has already been corrected.');
    errMismatch: Writeln('TPL Version mismatch.');
    errNoFile: Writeln('TPW.TPL not found.');
  end;
  Writeln;
  Writeln('Patch program Halted.');
  Halt(1);
end;

var
  F: File of Byte;
  B1, B2: Byte;

begin
  Assign(F, 'tpw.tpl');
  {$I-}
  Reset(F);
  {$I+}
  if IOResult <> 0 then
    Error(errNoFile);
  Seek(F, $19AE);
  Read(F, B1);
  Read(F, B2);
  if (B1 = $9B) and (B2 = $74) then
    begin
      B1 := $CD;
      B2 := $75;
      Seek(F, $19AE);
      Write(F, B1);
      Write(F, B2);
      Writeln('TPW.TPL patch complete.');
    end
  else
    if (B1 = $CD) and (B2 = $75) then
      Error(ErrCorrect)
    else
      Error(ErrMismatch);
  Close(F)
end.
